type StringInterpolationOptions<Raw extends boolean | undefined> = {
    pattern?: RegExp;
    sanity?: boolean;
    raw?: Raw;
};
type StringInterpolationReturn<VariableValue extends any, OptionRaw> = Exclude<VariableValue, string | number> extends never ? Extract<OptionRaw, boolean> extends true ? (string | VariableValue)[] : string : (string | VariableValue)[];
/**
 * Takes in a string containing variables and an object containing variables for interpolation. Accepts options.
 */
declare function stringInterpolation<VariableValue extends any, OptionRaw extends boolean | undefined>(s: string, v: Record<PropertyKey, VariableValue>, { pattern: p, sanity: S, raw: r, }?: StringInterpolationOptions<OptionRaw>): StringInterpolationReturn<VariableValue, OptionRaw>;

export { stringInterpolation };
